import java.io.*;

import javax.imageio.*;
import javax.swing.*;
import java.awt.*;
import java.awt.image.*;

public class BufferedImageProcessExample extends Graphics2DExample{

  public static void main(String args[]){new BufferedImageProcessExample();}

  BufferedImage b;
  
  public BufferedImageProcessExample()
  {
    super();
    
    try
    {
        b = ImageIO.read(new File("driveway.jpg"));
        int width = b.getWidth();
        int height = b.getHeight();
        
        for(int y=0; y<height; y++)
          for(int x=0; x<width; x++)
          {
            int pixel = b.getRGB(x,y);
          
            // Extract individual colour components
            int red =(pixel & 0x00ff0000) >> 16;
            int green = (pixel & 0x0000ff00) >> 8;
            int blue = pixel & 0x000000ff;
          
            // Perform the greyscale operation
            int grey = (red + green + blue)/3;
            
            // Create representation of pixel using default ARGB colour model
            pixel = 0xff000000 | (grey<<16) | (grey<<8) | grey;
          
            b.setRGB(x,y,pixel);
          }
        
        setPreferredSize(new Dimension(width, height));
        frame.pack();
    }
    catch(IOException ioe){System.out.println(ioe.toString());}
  }
  
  public void paint(Graphics g)
  {
      Graphics2D g2d = (Graphics2D)g;
      g2d.drawImage(b, 0, 0, this);
  }
}
