import java.awt.*;
import java.awt.image.*;

public class ImageProcessExample extends ImageLoadExample
{
  public static void main(String[] args){new ImageProcessExample();}
  
  public ImageProcessExample()
  { 
    super();
    
    i = Toolkit.getDefaultToolkit().createImage("greatwall.jpg");
    waitForImage(i);
    
    int width = i.getWidth(this);
    int height = i.getHeight(this);
    int[] pixels = new int[width*height];
    
    try{
      // Grab the pixels and put them in the array called pixels
    PixelGrabber grabber = new PixelGrabber(i,0,0,width,height,
        pixels,0,width);
    grabber.grabPixels();}
    catch(InterruptedException e){System.out.println(e.toString());}
    

    // Process each of the pixels individually
    for(int index = 0; index < width*height; index++)
      {
        int pixel = pixels[index];
        int red = (pixel & 0x00ff0000) >> 16;
        int green = (pixel & 0x0000ff00) >> 8;
        int blue = pixel & 0x000000ff;
        
        red = 255 - red;
        green = 255 - green;
        blue = 255 - blue;

        pixels[index] = 0xff000000|(red<<16)|(green<<8)|blue;
      }
    
    // Create a new image from the processed data
    MemoryImageSource data = new MemoryImageSource(width, height, pixels,0,width);
   i = Toolkit.getDefaultToolkit().createImage(data);
   
   waitForImage(i);
   
    setPreferredSize(new Dimension(width, height));
    frame.pack();
  }
  
  public void paint(Graphics g)
  {
    g.drawImage(i, 0, 0, this);
  }
}
