import java.io.*;
import javax.imageio.*;
import java.awt.*;
import java.awt.image.*;
import java.awt.geom.*;

public class Translate2DExample extends BufferedImageLoadExample{

  public static void main(String args[]){new Translate2DExample();}

  public void paint(Graphics g)
  {
      Graphics2D g2d = (Graphics2D)g;
      
      double tx = 100.0;
      double ty = 40.0;
      
      // Degine the transformation matrix
      double[] matrix = {1.0, 0.0, 
                         0.0, 1.0, 
                         tx,  ty};
    
    AffineTransform translateTransform = new AffineTransform(matrix);
    
    // Set the interpolation type
    int interpolationType = AffineTransformOp.TYPE_NEAREST_NEIGHBOR;
    
    AffineTransformOp translateTransformOp = 
      new AffineTransformOp(translateTransform,
                            interpolationType);
    
    // Perform the transformation
    BufferedImage result = translateTransformOp.filter(b, null);
    g2d.drawImage(result, 0, 0, this);
  }
}


